' John Conway's Game of Life for Micromite MMBasic with TeraTerm
' Bill McKinley
'
' NOTE: If you make the matrix too small the Glider demo will cause an error
' and the matrix will not overwrite some of the text on the screen
' Make it too big and it will not fit on the screen
' A ratio of 2 of x to 1 of y gives a better looking display
MatX = 40   ' Matrix horizontal size
MatY = 25   ' Matrix vertical size
RandL = 0.3 ' For the randomizing of life less than =< RandL means there is life
            ' Make it high and you get a lot of cells but they die quickly
PT = 000    ' Pause time in mS between display updates
A$ = "O"    ' The character to display a live cell - X or O are OK 

' Zero based matrix has one more cell all round than is displayed
dim CurM(MatX+1, MatY+1) ' The current matrix of life
dim MewM(MatX+1, MatY+1) ' The next geration of life

ChkScr      ' Print intro
SetupTimer  ' Randomize by waiting for a keypress
ClrScr      ' Clear the screen (matrix area)
InitM       ' Initialize the random matrix (or demo)
do          ' Program loop
NextGen     ' Calculate the next generation
NextGen2    ' Calculate the next generation
'UpdateM     ' Update the matrix with the new generation
pause PT
loop until inkey$ <> "" ' loop forever or until a keypres

sub ChkScr ' Print intro
ClrScr
print "   CONWAY'S GAME OF LIFE"
print
print "   Press a key to start"
print "   and another to stop"
print "   G for a glider demo"
end sub

sub SetupTimer ' Wait for a key press to start timer
Do
  B$ = inkey$
loop until B$ <> ""
randomize timer
end sub

sub ClrScr 'Clear the screen area
PRINT CHR$(27) "[2J" CHR$(27) "[H"
end sub

sub InitM ' Initialise the matrix of life
if B$ = "g" or b$ = "G" then  'Set thr glider and target
  CurM(4,7) =1:CurM(5,7) =1:CurM(6,7)=1:CurM(6,6)=1: CurM(5,5)=1
  CurM(15,15) =1:CurM(15,16) =1:CurM(16,15)=1:CurM(16,16)=1    
else
for y=1 to MatY
  for x=1 to MatX
    if rnd() =< RandL then
      CurM(x,y) = 1
    else
      CurM(x,y) = 0
    end if
  next x
  print  
next y
end if
end sub

Sub NextGen ' Breed the next generation into a new matrix
print CHR$(27) "[H"
  for y=1 to MatY
    for x=1 to MatX
      ' Find the number of live adjacent cells
      adj=CurM(x-1,y-1)+CurM(x,y-1)+CurM(x+1,y-1)+CurM(x-1,y)
      adj=adj+CurM(x+1,y)+CurM(x-1,y+1)+CurM(x,y+1)+CurM(x+1,y+1)
      CC=CurM(x,y) ' Current cell
      if CC then print A$; else print " ";
      NC=0 ' Assume NewCell is dead
      if CC=0 then
        if adj=3 then NC=1 ' It's alive!
      else
        if adj=3 or adj=2 then NC=1 ' It's alive!
      end if
      MewM(x,y)=NC
    next x
    print
  next y
end sub

Sub NextGen2 ' Breed the next generation into a new matrix
print CHR$(27) "[H"
  for y=1 to MatY
    for x=1 to MatX
      ' Find the number of live adjacent cells
      adj=MewM(x-1,y-1)+MewM(x,y-1)+MewM(x+1,y-1)+MewM(x-1,y)
      adj=adj+MewM(x+1,y)+MewM(x-1,y+1)+MewM(x,y+1)+MewM(x+1,y+1)
      CC=MewM(x,y) ' Current cell
      if CC then print A$; else print " ";
      NC=0 ' Assume NewCell is dead
      if CC=0 then
        if adj=3 then NC=1 ' It's alive!
      else
        if adj=3 or adj=2 then NC=1 ' It's alive!
      end if
      CurM(x,y)=NC
    next x
    print
  next y
end sub